#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global flofile; 
global indexdata1; 
global indexdata2; 
global indexdata3; 
global indexdata4; 
global indexdata5; 
global indexdata6; 
global indnum; 
global lcmd; 
global newi; 
global prt; 
global psfile; 
global titledata; 
global typedata; 
global widget; 

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
#Version check
global tk_version;
if {$tk_version < 4.2} {
    puts "enkf needs Tcl7.6/Tk4.2 later version."
    exit
}
}

init $argc $argv


proc redraw {} {
global box1;
global box2;
global box3;
global text1;
global text2;
global text3;
global text4;
global text5;
global text6;
global text7;
global text8;
global text9;
global text10;
global titledata;
global titlefont;
global indexfont;
global indexdata1;
global indexdata2;
global indexdata3;
global indexdata4;
global indexdata5;
global indexdata6;
global typedata;
global indnum;
if {$typedata == {fd35}} {
 wm title .top17 {flolytk-3.5fd}
} else {
 wm title .top17 {flolytk-3.5mo}
} 
.top17.can23 delete box1
.top17.can23 delete box2
.top17.can23 delete box3
.top17.can23 delete text1
.top17.can23 delete text2
.top17.can23 delete text3
.top17.can23 delete text4
.top17.can23 delete text5
.top17.can23 delete text6
.top17.can23 delete text7
.top17.can23 delete text8
.top17.can23 delete text9
.top17.can23 delete text10
.top17.can23 create rectangle 11.m 11.m 79.m 20.m -tag box1
.top17.can23 create text 45.m 15.m -anchor center -text $titledata -tag text1 -font $titlefont
if {$typedata == {fd35}} {
 .top17.can23 create rectangle 10.m 10.m 80.m 80.m -tag box2
 .top17.can23 create rectangle 11.m 60.m 79.m 68.m -tag box3
 if { 0 < $indnum} {
  .top17.can23 create text 45.m 22.m -anchor n -text $indexdata1 -tag text2 -font $indexfont
 }
 if { 1 < $indnum} {
  .top17.can23 create text 45.m 27.m -anchor n -text $indexdata2 -tag text3 -font $indexfont
 }
 if { 2 < $indnum} {
  .top17.can23 create text 45.m 32.m -anchor n -text $indexdata3 -tag text4 -font $indexfont
 }
 if { 3 < $indnum} {
  .top17.can23 create text 45.m 37.m -anchor n -text $indexdata4 -tag text5 -font $indexfont
 }
 if { 4 < $indnum} {
  .top17.can23 create text 45.m 42.m -anchor n -text $indexdata5 -tag text6 -font $indexfont
 }
 if { 5 < $indnum} {
  .top17.can23 create text 45.m 47.m -anchor n -text $indexdata6 -tag text7 -font $indexfont
 }
 .top17.can23 create text 45.m 64.m -anchor center -text $titledata -tag text8 -font $titlefont
 .top17.can23 create text 12.m 70.m -anchor nw -text {< Protect} -tag text9
 .top17.can23 create text 12.m 75.m -anchor nw -text {< Enable} -tag text10
} else {
 .top17.can23 create rectangle 10.m 10.m 80.m 80.m -tag box2
 .top17.can23 create rectangle 11.m 57.m 79.m 63.m -tag box3
 if { 0 < $indnum} {
  .top17.can23 create text 45.m 22.m -anchor n -text $indexdata1 -tag text2 -font $indexfont
 }
 if { 1 < $indnum} {
  .top17.can23 create text 45.m 27.m -anchor n -text $indexdata2 -tag text3 -font $indexfont
 }
 if { 2 < $indnum} {
  .top17.can23 create text 45.m 32.m -anchor n -text $indexdata3 -tag text4 -font $indexfont
 }
 if { 3 < $indnum} {
  .top17.can23 create text 45.m 37.m -anchor n -text $indexdata4 -tag text5 -font $indexfont
 }
 if { 4 < $indnum} {
  .top17.can23 create text 45.m 42.m -anchor n -text $indexdata5 -tag text6 -font $indexfont
 }
 if { 5 < $indnum} {
  .top17.can23 create text 45.m 47.m -anchor n -text $indexdata6 -tag text7 -font $indexfont
 }
 .top17.can23 create text 45.m 60.m -anchor center -text $titledata -tag text8 -font $titlefont
 .top17.can23 create text 12.m 64.m -anchor nw -text {< Protect} -tag text9
 .top17.can23 create text 12.m 72.m -anchor nw -text {< Enable} -tag text10
}
}

proc main {argc argv} {
global titledata; 
global titlefont;
global indexfont;
global indexdata1; 
global indexdata2; 
global indexdata3; 
global indexdata4; 
global indexdata5;
global indexdata6; 
global typedata;  
global prt; 
global newi;
global psfile; 
global flofile; 
global box1;
global box2;
global box3;
global text1;
global text2;
global text3;
global text4;
global text5;
global text6;
global text7;
global text8;
global text9;
global text10;
global indnum;
global lcmd;
set prt {lpr}
set newi {}
set psfile {floly.ps}
set flofile {new.flo}
set titledata {New Title}
set titlefont {Mincho:Helvetica-Bold-12}
set indexfont {Mincho:Helvetica-Bold-12}
set indexdata1 {Index}
set indexdata2 {}
set indexdata3 {}
set indexdata4 {}
set indexdata5 {}
set indexdata6 {}
set typedata {fd35}
set indnum 1
set lcmd {lpr}
}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 286x304+222+146
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "flolytk-3.5fd"
    menubutton $base.men17 \
        -menu .top17.men17.m -padx 4 -pady 3 -text File 
    menu $base.men17.m \
        -cursor {} 
    $base.men17.m add command \
        \
        -command {global typedata;
global titledata;
global titlefont;
global indexfont;
global indexdata1;
global indexdata2;
global indexdata3;
global indexdata4;
global indexdata5;
global indexdata6;
global box1;
global box2;
global box3;
global text1;
global text2;
global text3;
global text4;
global text5;
global text6;
global text7;
global text8;
global text9;
global text10;
global flofile;
global indnum;
.top17.can23 delete box1
.top17.can23 delete box2
.top17.can23 delete box3
.top17.can23 delete text1
.top17.can23 delete text2
.top17.can23 delete text3
.top17.can23 delete text4
.top17.can23 delete text5
.top17.can23 delete text6
.top17.can23 delete text7
.top17.can23 delete text8
.top17.can23 delete text9
.top17.can23 delete text10
set types {
{{Floly Files} {.flo}}
}
set flofile [tk_getOpenFile -filetypes $types -title "Load File" -initialfile $flofile]
set fileIdr [open $flofile r 0600]
set typedata [gets $fileIdr]
set titledata [gets $fileIdr]
set indexdata1 [gets $fileIdr]
set indexdata2 [gets $fileIdr]
set indexdata3 [gets $fileIdr]
set indexdata4 [gets $fileIdr]
set indexdata5 [gets $fileIdr]
set indexdata6 [gets $fileIdr]
close $fileIdr
set indnum 6
redraw} \
        -label Open 
    $base.men17.m add command \
        \
        -command {global typedata;
global titledata;
global indexdata1;
global indexdata2;
global indexdata3;
global indexdata4;
global indexdata5;
global indexdata6;
set types {
{{Floly Files} {.flo}}
}
#global flofile
set flofile [tk_getSaveFile -filetypes $types -title "Save File" -initialfile $flofile]
set fileId [open $flofile w 0600]
puts $fileId $typedata
puts $fileId $titledata
puts $fileId $indexdata1
puts $fileId $indexdata2
puts $fileId $indexdata3
puts $fileId $indexdata4
puts $fileId $indexdata5
puts $fileId $indexdata6
close $fileId} \
        -label Save 
    $base.men17.m add separator
    $base.men17.m add command \
        -command exit -label Quit 
    menubutton $base.men18 \
        -menu .top17.men18.m -padx 4 -pady 3 -text Edit 
    menu $base.men18.m \
        -cursor {} 
    $base.men18.m add command \
        -command {Window show .top32} -label Title 
    $base.men18.m add command \
        \
        -command {global indexdata1; 
global indexdata2; 
global indexdata3; 
global indexdata4; 
global indexdata5;
global indexdata6; 
Window show .top36
.top36.cpd38.01 delete 0 end
if {0 < $indnum} {.top36.cpd38.01 insert end $indexdata1}
if {1 < $indnum} {.top36.cpd38.01 insert end $indexdata2}
if {2 < $indnum} {.top36.cpd38.01 insert end $indexdata3}
if {3 < $indnum} {.top36.cpd38.01 insert end $indexdata4}
if {4 < $indnum} {.top36.cpd38.01 insert end $indexdata5}
if {5 < $indnum} {.top36.cpd38.01 insert end $indexdata6}} \
        -label Index 
    $base.men18.m add separator
    $base.men18.m add command \
        \
        -command {global titlefont;
set titlefont [eval exec xfontsel -print]
redraw} \
        -label {Title Font} 
    $base.men18.m add command \
        \
        -command {global indexfont;
set indexfont [eval exec xfontsel -print]
redraw} \
        -label {Index Font} 
    menubutton $base.men19 \
        -menu .top17.men19.m -padx 4 -pady 3 -text Type 
    menu $base.men19.m \
        -cursor {} 
    $base.men19.m add command \
        -command {set typedata fd35
redraw} -label 3.5FD 
    $base.men19.m add command \
        -command {set typedata mo35
redraw} -label 3.5MO 
    menubutton $base.men20 \
        -menu .top17.men20.m -padx 4 -pady 3 -text Print 
    menu $base.men20.m \
        -cursor {} 
    $base.men20.m add command \
        \
        -command {global psfile
set types {
{{Postscript Files} {.ps}}
}
set psfile [tk_getSaveFile -filetypes $types -title "PS File" -initialfile $psfile]
if {$psfile != {}} {
 .top17.can23 postscript -file $psfile -pagex 0.i -pagey 11.i -pageanchor nw
}} \
        -label {to PS File} 
    $base.men20.m add command \
        -command {Window show .top44} -label {to lpr} 
    $base.men20.m add command \
        \
        -command {global lcmd;
set lcmd {}
.top17.can23 postscript -file floly.ps -pagex 0.i -pagey 11.i -pageanchor nw
set lcmd [concat {exec} {gv} {floly.ps}]
eval $lcmd} \
        -label {to gv} 
    menubutton $base.men20.men21 \
        -menu .top17.men20.men21.m -padx 4 -pady 3 -text menu 
    menu $base.men20.men21.m
    menubutton $base.men22 \
        -menu .top17.men22.m -padx 4 -pady 3 -text Help 
    menu $base.men22.m \
        -cursor {} 
    $base.men22.m add command \
        \
        -command tk_messageBox\ -icon\ info\ -type\ ok\ \\\n\ -title\ \"About\ Flolytk\ 1.0.1\"\ \\\n\ -message\ \ \"Floppy\ &\ MO\ Label\ Maker.\\n-Free\ software-\\n\ Copyright\ (c)\ 1998\ Cow\ Project\ Workshop\" \
        -label About 
    canvas $base.can23 \
        -background #fefefe -borderwidth 2 -height 207 -relief ridge \
        -width 295 
    button $base.but30 \
        -command exit -padx 9 -pady 3 -text Quit 
    label $base.lab18 \
        -anchor e -borderwidth 1 -relief sunken -text new.flo \
        -textvariable flofile 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.men17 \
        -x 0 -y 0 -anchor nw -bordermode ignore 
    place $base.men18 \
        -x 40 -y 0 -width 40 -height 24 -anchor nw -bordermode ignore 
    place $base.men19 \
        -x 80 -y 0 -anchor nw -bordermode ignore 
    place $base.men20 \
        -x 120 -y 0 -anchor nw -bordermode ignore 
    place $base.men20.men21 \
        -x 75 -y 55 -anchor nw -bordermode ignore 
    place $base.men22 \
        -x 170 -y 0 -anchor nw -bordermode ignore 
    place $base.can23 \
        -x 5 -y 23 -width 273 -height 255 -anchor nw -bordermode ignore 
    place $base.but30 \
        -x 225 -y 0 -width 53 -height 28 -anchor nw -bordermode ignore 
    place $base.lab18 \
        -x 10 -y 280 -width 264 -height 18 -anchor nw -bordermode ignore 
}

proc vTclWindow.top32 {base} {
    if {$base == ""} {
        set base .top32
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 345x83+234+182
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Edit Title"
    label $base.lab33  -borderwidth 1 -relief raised -text Title: 
    entry $base.ent34  -textvariable titledata 
    button $base.but35  -command {Window hide .top32
redraw} -padx 9 -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab33  -x 5 -y 5 -anchor nw -bordermode ignore 
    place $base.ent34  -x 5 -y 25 -width 330 -height 24 -anchor nw -bordermode ignore 
    place $base.but35  -x 145 -y 50 -anchor nw -bordermode ignore
}

proc vTclWindow.top36 {base} {
    if {$base == ""} {
        set base .top36
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 369x182+104+277
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Edit Index"
    label $base.lab37  -borderwidth 1 -relief raised -text Index 
    frame $base.cpd38  -borderwidth 1 -height 30 -relief raised -width 30 
    listbox $base.cpd38.01  -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-*  -xscrollcommand {.top36.cpd38.02 set}  -yscrollcommand {.top36.cpd38.03 set} 
    scrollbar $base.cpd38.02  -borderwidth 1 -command {.top36.cpd38.01 xview} -orient horiz  -width 10 
    scrollbar $base.cpd38.03  -borderwidth 1 -command {.top36.cpd38.01 yview} -orient vert  -width 10 
    label $base.lab39  -borderwidth 1 -relief raised -text {New data} 
    entry $base.ent40  -textvariable newi 
    button $base.but41   -command {if {$newi != {} } {
 if {[.top36.cpd38.01 curselection] == {}} {
  .top36.cpd38.01 insert end $newi
 } else {
  .top36.cpd38.01 insert [.top36.cpd38.01 curselection] $newi
 }
 set newi {}
}}  -padx 9 -pady 3 -text Add 
    button $base.but42   -command {if {[.top36.cpd38.01 curselection] != {} } {
.top36.cpd38.01 delete [.top36.cpd38.01 curselection]
}}  -padx 9 -pady 3 -text Delete 
    button $base.but43   -command {global indexdata1;
global indexdata2;
global indexdata3;
global indexdata4;
global indexdata5;
global indexdata6;
global indnum;
set indnum [.top36.cpd38.01 index end]
if { 0 < $indnum} {
 set indexdata1 [.top36.cpd38.01 get 0]
} else {set indexdata1 {}}
if { 1 < $indnum} {
 set indexdata2 [.top36.cpd38.01 get 1]
} else {set indexdata2 {}}
if { 2 < $indnum} {
 set indexdata3 [.top36.cpd38.01 get 2]
} else {set indexdata3 {}}
if { 3 < $indnum} {
 set indexdata4 [.top36.cpd38.01 get 3]
} else {set indexdata4 {}}
if { 4 < $indnum} {
 set indexdata5 [.top36.cpd38.01 get 4]
} else {set indexdata5 {}}
if { 5 < $indnum} {
 set indexdata6 [.top36.cpd38.01 get 5]
} else {set indexdata6 {}}
Window hide .top36
redraw}  -padx 9 -pady 3 -text OK 
    button $base.but17   -command {set types {
{{All Files} {*}}
}
set newi [tk_getOpenFile -filetypes $types -title "Select file"]
if {$newi != {} } {
.top36.cpd38.01 insert end $newi
set newi {}
}}  -padx 9 -pady 3 -text {Get Filename} 
    button $base.but18   -command {if {$newi != {}} {
 if {[.top36.cpd38.01 curselection] != {}} {
  .top36.cpd38.01 insert [.top36.cpd38.01 curselection] $newi
  .top36.cpd38.01 delete [.top36.cpd38.01 curselection]
 }
 set newi {}
} else {
 if {[.top36.cpd38.01 curselection] != {}} {
  set newi [.top36.cpd38.01 get [.top36.cpd38.01 curselection]]
 }
}}  -padx 9 -pady 3 -text Edit 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab37  -x 5 -y 5 -anchor nw -bordermode ignore 
    place $base.cpd38  -x 50 -y 5 -width 315 -height 100 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd38 0 -weight 1
    grid rowconf $base.cpd38 0 -weight 1
    grid $base.cpd38.01  -in .top36.cpd38 -column 0 -row 0 -columnspan 1 -rowspan 1  -sticky nesw 
    grid $base.cpd38.02  -in .top36.cpd38 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd38.03  -in .top36.cpd38 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.lab39  -x 5 -y 115 -anchor nw -bordermode ignore 
    place $base.ent40  -x 70 -y 115 -width 295 -height 24 -anchor nw -bordermode ignore 
    place $base.but41  -x 5 -y 145 -anchor nw -bordermode ignore 
    place $base.but42  -x 60 -y 145 -anchor nw -bordermode ignore 
    place $base.but43  -x 325 -y 145 -anchor nw -bordermode ignore 
    place $base.but17  -x 205 -y 145 -anchor nw -bordermode ignore 
    place $base.but18  -x 135 -y 145 -anchor nw -bordermode ignore
}

proc vTclWindow.top44 {base} {
    if {$base == ""} {
        set base .top44
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 256x65+62+335
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Printer Setting"
    label $base.lab46  -borderwidth 1 -relief raised -text Printer: 
    entry $base.ent47  -textvariable prt 
    button $base.but48   -command {global prt;
global lcmd;
set lcmd {}
.top17.can23 postscript -file floly.ps -pagex 0.i -pagey 11.i -pageanchor nw
set lcmd [concat {exec} $prt {floly.ps}]
eval $lcmd 
Window hide .top44}  -padx 9 -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab46  -x 5 -y 5 -anchor nw -bordermode ignore 
    place $base.ent47  -x 75 -y 5 -width 175 -height 24 -anchor nw -bordermode ignore 
    place $base.but48  -x 104 -y 30 -width 40 -height 28 -anchor nw -bordermode ignore
}

Window show .
Window show .top17

main $argc $argv
